//=============================================================================
//
//                                    DSDS
//                         (Derks Simple Daily System)
//                   **:.(`'.`.') .:**
//
//                            "Simple Daily System"
//                          Idea credit to IcfxTrader
//                        Copyright  2007, Derk Wehler
//
//                                             $Workfile::                   $
//                                             $Revision::                   $
//                                               $Author::                   $
//                                                 $Date::                   $
//
//=============================================================================
#property copyright "Copyright  2007, Derk Wehler"
#property link      "derkwehler@gmail.com"

#include <LibOrderReliable.mqh>
#include <LibDerksUtils.mqh>


// Input parameters
extern string	S1 					= "======== MONEY MANAGEMENT";
extern string	S1a 				= "---------------- General";
extern double	Lots 				= 0.1;
extern double	MinLots 			= 0.01;
extern double	MaxLots 			= 100.0;
extern bool		SplitOrder			= false;
extern string	S1b 				= "---------------- Increase w/Account";
extern bool 	UseMoneyManagement 	= true;
extern bool		BaseOnSL			= true;
extern bool		UseSimpleRatio		= false;
extern double	TradeSizePercent 	= 4.0;
extern string	S1c 				= "---------------- Auxiliary MM Type";
extern string	S1d 				= "    0 : None";
extern string	S1e 				= "    1 : Martingale";
extern string	S1f 				= "    2 : Dual Win (Binary)";
extern string	S1g 				= "    3 : Incremental Recovery";
extern string	S1h 				= "    4 : SuperSafe MM";
extern string	S1j 				= "    5 : D\'Alembert";
//extern string	S1i 				= "    6 : Extreme";
extern int	 	AuxiliaryMM_Type 	= 5;
extern string	S1t 				= "---------------- Martingale MM Settings";
extern double	MartingaleMult		= 5;
extern double	MartMaxLossPercent	= 20.0;
extern string	S1u 				= "---------------- Recovery MM Settings";
extern double	RecoveryPercent		= 15.0;
extern double	MaxRecoveryMult		= 2.0;
extern string	S1v 				= "---------------- D\'Alembert MM Settings";
extern string	S1v1 				= "  Set to number of pips ahead we must be";
extern string	S1v2 				= "  before lots will be reset.  Use 1 for";
extern string	S1v3 				= "  just past breakeven, use -1 to disable";
extern int		ResetPips			= -1;
extern string	S1z 				= " ";
extern string	S2 					= "======== INDICATOR / ENTRY SETTINGS";
extern string	S2b 				= "---------------- Moving Average";
extern bool		UseMA				= true;
extern int		PeriodMA			= 20;
extern int		MethodMA			= 0;
extern int		ApplyToMA			= 0;
extern string	S2c 				= "---------------- Parabolic";
extern bool		UsePSAR				= true;
extern double	StepPSAR			= 0.02;
extern double	MaxPSAR				= 0.2;
extern string	S2d 				= "---------------- Average True Range";
extern int		PeriodATR			= 10;
extern int		MinATR				= 50;
extern string	S2e 				= "---------------- Hours (Broker time)";
extern string	sHours1				= "  IBFX is GMT-1; 07:00 Frankfurt Open,";
extern string	sHours2				= "     08:00 London Open, 13:00 NY Open.";
extern string	sHours3				= "  FXDD is GMT+2; 10:00 Frankfurt Open,";
extern string	sHours4				= "     11:00 London Open, 16:00 NY Open.";
extern string 	Session1Start		= "99:99"; //"09:00";  // EUR session      ibfx is GMT - 1, FXDD is GMT + 2 
extern string 	Session1End			= "99:99"; //"13:00";
extern string 	Session2Start		= "99:99"; //"15:00";  // NY session
extern string 	Session2End			= "99:99"; //"19:00";
extern string	S2z 				= " ";
extern string	S3	 				= "======== ATR Exit";
extern bool		UseATR_Exit			= false;
extern bool		ATR_ExitAll			= false;
extern int 		ATR_Period			= 5;
extern double 	ATR_PipMult 		= 4;	// try 2.0 - 15.0
extern int 		ATR_MinPips			= 50;
extern int 		ATR_MaxPips			= 500;
extern string	S3z 				= " ";
extern string	S4 					= "======== TP, SL & TRAIL";
extern string	S4a 				= "---------------- TakeProfit";
extern bool		UseAutoTP			= true;
extern int		NumDaysATR			= 60;
extern double 	TP_PercentATR		= 75.0;
extern double 	SplitPercentATR		= 90.0;
extern int		TakeProfit	 		= 0;
extern int		SplitTP		 		= 0;
extern string	S4a1 				= "---------------- StopLoss";
extern bool		SetEqualToTP		= true;
extern int		StopLoss	 		= 0;
extern string	S4a2 				= "---------------- Trailing Stop";
extern int	 	TrailingType	 	= 0;
extern int	 	TrailValue		 	= 0;
extern string	s4b					= "---------------- Type 3 settings:";
extern int	 	FirstMove 			= 0;
extern int	 	FirstSL				= 0;
extern int	 	SecondMove 			= 0;
extern int	 	SecondSL			= 0;
extern int	 	ThirdMove 			= 0;
extern string	s4c					= "---------------- Type 7 settings:";
extern double	PSAR_Step			= 0.02;
extern double	PSAR_Max			= 0.2;
extern string	s4d					= "---------------- Type 8 settings:";
extern int		MA_Period			= 34;
extern int		MA_Shift			= 0;
extern int		MA_Method			= 1;
extern int		MA_ApplyTo			= 0;
extern string	s4e					= "---------------- Type 9 settings:";
extern int		PCS_Period 			= 9;
extern double	PCS_Risk 			= 0.3;
extern string	S4z 				= " ";
extern string	S5	 				= "======== GENERAL EA";
extern bool		CheckEveryTick		= false;
extern bool		UseAlert			= false;
extern bool		UseEmail			= false;
extern bool		UseMarket			= false;
extern bool		Use2Step			= false;
extern int		Slippage			= 1;
extern int		MagicSeed			= 3300000;
extern string	TradeComment		= "DSDS";
extern int		DebugLevel 			= 5;


int 	MagicNumber;
int		LastTradeDir;
int		SignalCandle;
bool	CandleAnnounced;
bool	OkToTrade;
string	ExtraComment;
string	Asterisk;


//=============================================================================
//	expert initialization function
//=============================================================================
int init()
{
	// Set up magic numbers:
    MagicNumber = MagicSeed + SymbolConst2Val(Symbol())*100 + TimeFrameConst2Val(Period());
	CandleAnnounced = false;
	OkToTrade = true;
	if (!UsePSAR  &&  !UseMA)
	{
		Alert("Both Parabolic and Moving Average disabled; no way to enter trade!");
		OkToTrade = false;
	}

	// Set trail params	
	SetParabolicParams(PSAR_Step, PSAR_Max);
	SetMovingAverageParams(MA_Period, MA_Shift, MA_Method, MA_ApplyTo); 
	SetPriceChannelStopParams(PCS_Period, PCS_Risk);
	
	SignalCandle = 1;
	if (CheckEveryTick)
		SignalCandle = 0;
		
	return (0);
}
  

//=============================================================================
//	expert deinitialization function
//=============================================================================
int deinit()
{
	return (0);
}


//=============================================================================
//
// PURPOSE: 
//     Check to see that it is okay to place a trade right now
//
// RETURN VALUE:
//      True: Okay to trade right now
//     False: Forbidden to place a new trade at this time
//
//=============================================================================
bool TradingOkay()
{
   	string fn = "TradingOkay()";

	bool sess1Valid = true;
	if (StringSubstr(Session1Start, 0, 2) == "99"  ||  StringSubstr(Session1End, 0, 2) == "99")
		sess1Valid = false;
	bool sess2Valid = true;
	if (StringSubstr(Session2Start, 0, 2) == "99"  ||  StringSubstr(Session2End, 0, 2) == "99")
		sess2Valid = false;
		
	// Deal with time constraints	
	if ( !(sess1Valid  ||  sess2Valid) )
		return(true);

	// Check for specific time, return true, if current time is within this range.
	if (sess1Valid)
		if (IsPast(Session1Start)  &&  !IsPast(Session1End))
			return(true);

	// Check for specific time, return true, if current time is within this range.
	if (sess2Valid)
		if (IsPast(Session2Start)  &&  !IsPast(Session2End)) 
			return(true);

	return(false);
}


//=============================================================================
//	Put up alert, or send email if option set
//=============================================================================
void DoAlert(string str)
{
	if (IsTesting())
		return;
		
	if (UseAlert)
		Alert(str);

	if (UseEmail)
		SendMail(TradeComment, str);
}


//=============================================================================
//
// PURPOSE:
//     Potentially exit positions, based on ATR Indicator
//
// RETURN VALUE:
//     true if any trades closed, false otherwise
//
//=============================================================================
bool ExitOnATR()
{ 
   	string fn = "CheckExitOnATR()";

	if (!UseATR_Exit)
		return(false);
		
		
	bool	retVal = false;
	double	price;
	int 	pipsProfit, ticket, type;
	double 	pipCount = (ATR_PipMult/PointX()) * (iATR(NULL, 0, ATR_Period, 0));
	
	pipCount = MathMax(pipCount, ATR_MinPips);
	pipCount = MathMin(pipCount, ATR_MaxPips);

	for (int cnt=OrdersTotal()-1; cnt >= 0; cnt--)
	{
		OrderSelect(cnt, SELECT_BY_POS);
		if (OrderType() > OP_SELL  ||  OrderMagicNumber() != MagicNumber)
			continue;
			
		if (OrderType() == OP_SELL)
		{
			price = Ask;
			pipsProfit = (OrderOpenPrice() - Ask) / PointX(); 
		}
		else 
		{
			price = Bid;
			pipsProfit = (Bid - OrderOpenPrice()) / PointX(); 
		}
		
		if (pipsProfit > pipCount)
		{
			if (ATR_ExitAll)
			{
				type = OrderType();
				DoExit(type);
				Print("");
				Print(">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>");
				Print("            EXITED ON ATR; CLOSED ALL " + OrderType2String(type) + " TRADES");
				Print("<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<");
				Print("");
				return(true);
			}
			
			ticket = OrderTicket();
			if (OrderCloseReliable(ticket, OrderLots(), price, Slippage, CLR_NONE))
			{
				retVal = true;
				Print("");
				Print(">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>");
				Print("               EXITED ON ATR; TICKET #" + ticket);
				Print("<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<");
				Print("");
			}
		}
	}
	return(retVal);
}


//=============================================================================
//
// PURPOSE:
//     Calculate the number of lots to trade.
//
// PARAMETERS:
//	   magic: The magic number used to trade (used by DualWin system only)
//
// RETURN VALUE:
//     The number of lots to trade
//
//=============================================================================
double CalcLots(int magic)
{
   	string fn = "CalcLots()";

	double maxMartingaleLots;
	double lots = Lots;
	double mmSL = StopLoss;
	double mMult = MartingaleMult;
	
	ExtraComment = "";

	// Take care of basic MM, basing lots on a percetage of the account
	if (UseMoneyManagement)
	{
		if (UseSimpleRatio)
			lots = CalcLotsSimpleRatio(TradeSizePercent, MinLots, MaxLots);
		else
		{
			if (!BaseOnSL)
				mmSL = 0;
			lots = CalcLotsGivenRisk(TradeSizePercent, MinLots, MaxLots, mmSL);
		}
	}
	double baseLots = lots;

	// Handle Martingale MM if enabled
	if (AuxiliaryMM_Type == 1)
	{
		// Setup the martingale multipler based on SL:TP ratio
		if (MartingaleMult == -1)
			mMult = NormalizeDouble((StopLoss / TakeProfit), 4);
		
		maxMartingaleLots = CalcLotsGivenRisk(MartMaxLossPercent, MinLots, MaxLots, StopLoss);
		lots = GetMartingaleLots(magic, lots, MaxLots, mMult);
		
		if (lots != baseLots)
		{
			ExtraComment = " (M" + DoubleToStr(mMult, 0) + "x +" + DoubleToStr(lots - baseLots, 2) + ")";

			// If SplitOrder is enabled, then we assume it has been enabled from previous trade(s)
			// If the last trade was a loss, GetMartingaleLots will return a number based on only 
			// the last trade, where as actually it was split and therefore then number of lots 
			// should be doubled (& will subsequently be split again when order placed).
			if (SplitOrder)
				lots *= 2.0;
		
			// Never bet more than user is prepared to lose, regardless
			lots = MathMin(lots, maxMartingaleLots);
		}
	}
	
	// Handle Dual Win (Binary) MM if enabled
	else if (AuxiliaryMM_Type == 2)
	{
		if (TakeProfit == 0)
			Alert("ERROR!! : Attempt to use DualWin MM system with zero TP; aborting");
		else if (SplitOrder)
			Alert("ERROR!! : Attempt to use DualWin MM system with SplitOrder enabled; aborting");
		else
			lots = GetDualWinLots(lots, magic, TakeProfit);
	}

	// Handle Incremental Recovery MM if enabled
	else if (AuxiliaryMM_Type == 3)
	{
		if (TakeProfit == 0)
			Alert("ERROR!! : Attempt to use Incremental Recovery MM with zero TP");
		else
			lots = GetIncrRecoveryLots(MagicNumber, lots, (lots*MaxRecoveryMult), RecoveryPercent, TakeProfit);
		
		if (lots > baseLots)
		{
			Debug(6, fn, "Done with IncrRecovery, Lots = " + lots);
			ExtraComment = " (R" + DoubleToStr(RecoveryPercent, 0) + "% +" + DoubleToStr(lots - baseLots, 2) + ")";
		}
	}
	
	// Handle SuperSafe Recovery MM if enabled
	else if (AuxiliaryMM_Type == 4)
	{
		lots = GetSuperSafeLots(MagicNumber, lots, MaxLots, false);
		
		if (lots > baseLots)
		{
			Debug(6, fn, "Done with SuperSafeMM, Lots = " + lots);
			ExtraComment = " (SS +" + DoubleToStr(lots - baseLots, 2) + ")";
		}
	}
	
	// Handle SuperSafe Recovery MM if enabled
	else if (AuxiliaryMM_Type == 5)
	{
		lots = GetDAlembertLots(MagicNumber, lots, MaxLots, ResetPips);
		
		if (lots > baseLots)
		{
			Debug(6, fn, "Done with SuperSafeMM, Lots = " + lots);
			ExtraComment = " (DL +" + DoubleToStr(lots - baseLots, 2) + ")";
		}
	}
	
	return(lots);
}


//=============================================================================
//
// PURPOSE:
//     Go through possible entry signals one by one, and short-circuit 
//     out early if any fail (more efficient for back-testing)
//
// RETURN VALUE:
//     OP_BUY: Enter long position
//    OP_SELL: Enter short position 
//         -1: Enter no position at this time
//
//=============================================================================
int CheckEntrySignals()
{
   	string fn = "CheckEntrySignals()";

	if (!TradingOkay())
	{
		Debug(6, fn, "OUTSIDE OF TRADING SESSION, RETURNING NO TRADE");
		return(-1);
	}

	int res = -1;
	int maRes = -1;
	int psarRes = -1;
	
	// Get ATR value in pips
	double atr = iATR(NULL, 0, PeriodATR, SignalCandle) / PointX();
	if (atr < MinATR)
		return(res);
		
	if (UseMA)
	{
		double ma = iMA(NULL, 0, PeriodMA, 0, MethodMA, ApplyToMA, SignalCandle);
		if (Bid > ma)
		{
			Debug(1, fn, "MA in Buy mode...");
			res = OP_BUY;
		}
		else if (Bid < ma)
		{
			Debug(1, fn, "MA in Sell mode...");
			res = OP_SELL;
		}
	}

	if (UsePSAR)
	{
		double psar = iSAR(NULL, 0, StepPSAR, MaxPSAR, SignalCandle);
		if (Bid > psar)
		{
			Debug(1, fn, "PSAR in Buy mode...");
			if (res == OP_SELL)
				return(-1);
			res = OP_BUY;
		}
		else if (Bid < psar)
		{
			Debug(1, fn, "PSAR in Sell mode...");
			if (res == OP_BUY)
				return(-1);
			res = OP_SELL;
		}
	}

	Debug(1, fn, "Returning " + OrderType2String(res) + " signal");
	
	return(res);
}


//=============================================================================
//
// PURPOSE:
//     Go through possible exit signals one by one, and short-circuit 
//     out early if any succeed (more efficient for back-testing)
//
// PARAMETERS:
//        op: The direction in which to check for an exit (OP_BUY or OP_SELL)
//
// RETURN VALUE:
//      true: Exit position
//     false: Exit no position at this time
//
//=============================================================================
bool CheckExitSignals(int op)
{
   	string fn = "CheckExitSignals()";

}


//=============================================================================
//
// PURPOSE:
//     Enter a trade with the given parameters
//
// PARAMETERS:
//	     op: The type of trade to enter
//     lots: The number of lots to trade
//       TP: The take profit to use for this trade
//    price: The price to place pending, or zero for market order
//
// RETURN VALUE:
//     The ticket number of the trade entered
//
//=============================================================================
int DoEntry(int op, double lots, double TP=0, double price=0)
{
   	string fn = "DoEntry()";

	int 	mult, ticket;
	color	clr;
	double 	sl, tp;
	double	prc;

	sl = 0;
	tp = 0;
	prc = price;
	if (op % 2 == 0)	// OP_BUY || OP_BUYSTOP || OP_BUYLIMIT)
	{
		mult = 1;
		clr = Green;
		if (prc == 0)
			prc = Ask;
	}
	else 
	if (op % 2 == 1)	// OP_SELL || OP_SELLSTOP || OP_SELLLIMIT
	{
		mult = -1;
		clr = Red;
		if (prc == 0)
			prc = Bid;
	}
	
	if (StopLoss > 0)
		sl = prc - mult * StopLoss*PointX();
	if (TP > 0)
		tp = prc + mult * TP*PointX();
	
	// Set up the order comment for this trade
	string cmnt = TradeComment;
	if (ExtraComment != "") 
		cmnt = ExtraComment + " - " + cmnt;
	cmnt = Asterisk + cmnt;	// Add in asterisk (if there) for split trades
		
	// Enter trade
	if (UseMarket)
	{
		// We use the market version here so that we will have less chance of
		// getting an "Invalid Price" error.  But this could mean that the 
		// entry price is worse (slipped), especially in fast-moving markets.
		ticket = OrderSendReliableMKT(Symbol(), op, lots, prc, Slippage, 
									  sl, tp, cmnt, MagicNumber, 0, clr);
	}
	else if (Use2Step)
	{
		// On some brokers (namely ones that bridge to curenex), you have to do
		// the OrderSend with zero SL & TP, and then do an OrderModify to set them.
		ticket = OrderSendReliable2Step(Symbol(), op, lots, prc, Slippage, 
										sl, tp, cmnt, MagicNumber, 0, clr);
	}
	else
	{
		// Normal order placement
		ticket = OrderSendReliable(Symbol(), op, lots, prc, Slippage, 
								   sl, tp, cmnt, MagicNumber, 0, clr);
	}
	
	if (ticket > 0)
		DoAlert("Placed " + OrderType2String(op) + " order at " + prc);

	return(ticket);
}


//=============================================================================
//
// PURPOSE:
//     Exit all trades in a given direction
//
// PARAMETERS:
//	     op: The direction to enter trade
//     lots: The percentage to use if MM is enabled
//
// RETURN VALUE:
//     true: A trade was exited
//    false: No trade exited
//
//=============================================================================
bool DoExit(int op)
{
   	string fn = "DoExit()";

	int		cnt;
	bool	somethingClosed = false;
	color	clr;
	double 	price, sl, tp;

	if (op != OP_BUY && op != OP_SELL)
		return(false);
		
	for (cnt=OrdersTotal()-1; cnt >= 0; cnt--)
	{
		OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
		if (OrderSymbol() != Symbol() || 
			OrderMagicNumber() != MagicNumber || 
			OrderType() != op) 
			continue;
		
		price = Bid;
		clr = Green;
	
		if (op == OP_SELL)
		{
			price = Ask;
			clr = Red;
		}
	
		if (OrderClose(OrderTicket(), OrderLots(), price, Slippage, clr))
			somethingClosed = true;
	}
	
//	if (somethingClosed > 0)
//		DoAlert("Closed all " + OrderType2String(op) + " orders.");

	return(somethingClosed);
}


//=============================================================================
//
// PURPOSE:
//     Look for an object with a given name.  If it exists, return a signal 
//     to the EA to open a trade, even though a real signal does not exist.
//
// RETURN VALUE:
//     true if trade entered, false otherwise
//
//=============================================================================
bool CheckForForcedEntry()
{
	string fn = "CheckForForcedEntry()";
	int    entryDir = -1;
	
	// Modify this if it's okay for this EA to be in more 
	// than one trade at a time.
	if (NumOpenPositions(MagicNumber, OP_BOTH) > 0)
		return(false);

	if (ObjectFind("go_long") != -1)
	{
		ObjectDelete("go_long");
		Debug(1, fn, "FORCED ENTRY ACTIVATED: ENTERING BUY TRADE!");
		entryDir = OP_BUY;
	}
	else if (ObjectFind("go_short") != -1)
	{
		ObjectDelete("go_short");
		Debug(1, fn, "FORCED ENTRY ACTIVATED: ENTERING SELL TRADE!");
		entryDir = OP_SELL;
	}
	else
		return(false);
	
	if (OpenNewPosition(entryDir) >= 0)
		return(true);
}


//=============================================================================
//  Open a new position in the direction indicated.  Return new ticket #
//=============================================================================
int OpenNewPosition(int op)
{
	int 	ticket;
	double 	lotsMM = Lots;

	// First make sure we are not in any opposite trades
	DoExit(Opp(op));

	if (UseAutoTP)
	{
		double atr = iATR(NULL, 0, NumDaysATR, SignalCandle);
		TakeProfit = TP_PercentATR * (atr / PointX()) / 100;
		SplitTP = SplitPercentATR * (atr / PointX()) / 100;
	}
	if (SetEqualToTP)
		StopLoss = TakeProfit;
		
	// Open new position(s)
	lotsMM = CalcLots(MagicNumber);		// Calc the lots to use
	if (SplitOrder)
	{
		lotsMM = MathMax(NormalizeDouble(lotsMM/2, GetLotDigits()), MarketInfo(Symbol(), MODE_MINLOT));
		Asterisk = "*";
		DoEntry(op, lotsMM, SplitTP);
		Asterisk = "";
	}
	ticket = DoEntry(op, lotsMM, TakeProfit);
	if (ticket >= 0)
	{
		LastTradeDir = op;
		//GlobalVariableSet("EA_LastTradeDir", LastTradeDir);
		DoAlert(TimeToStr(TimeCurrent(), TIME_DATE|TIME_MINUTES) + ": " + OrderType2String(op) + " " + Symbol() + " @ " + Ask);
	}
	return(ticket);
}


//=============================================================================
//
// PURPOSE: 
//     Provide a central debug function where the candle time will be 
//     printed only once, and only if there is debug info during that run.
//     Must set "CandleAnnounced" back to false at the end of start()
//
//=============================================================================
void Debug(int priority, string funcName, string str)
{
	if (priority > DebugLevel  ||  IsOptimization())
		return;

	if (!CandleAnnounced)
	{
		Print("");
		Print("");
		Print(sp30 + "**._.**._.**._.**._.**._.**._.**._.**");
		Print(sp30 + "   CURRENT CANDLE  -  " + TimeToStr(TimeCurrent(), TIME_DATE|TIME_MINUTES|TIME_SECONDS) + "  -  Last Trade Direction: " + OrderType2String(LastTradeDir));
		Print(sp30 + "**._.**._.**._.**._.**._.**._.**._.**");
		CandleAnnounced = true;
	}	
	Print(sp30 + str + " :  " + funcName);
}


//=============================================================================
//	Expert start function
//=============================================================================
int start()
{
   	string fn = "start()";

	int 	op, ticket, exitPos, entryDir;
	bool	isNewCandle = IsNewCandle();

	if (!OkToTrade)
		return(0);
		
	// Reset each time for debuging purposes
	CandleAnnounced = false;	

	// Handle trailing stop adjustments
	if (TrailingType > 0 && NumOpenPositions(MagicNumber, OP_BOTH) > 0)
	{
		AdjTrailOnAllOrders(TrailingType, TrailValue, MagicNumber, OP_BOTH, 
							FirstMove, FirstSL, SecondMove, SecondSL, ThirdMove);
	}
	
	// Handle variable TP exit based on ATR
	ExitOnATR();

	// Check if the user has demanded the EA to enter a trade now
	if (!CheckForForcedEntry())
	{
		// Check for entry only once per candle (unless CheckEveryTick mode is active)
		if (isNewCandle  ||  CheckEveryTick)
		{
			// Check for exit
			if (CheckExitSignals(LastTradeDir))
				DoExit(LastTradeDir);

			// Check for entry signal
			entryDir = CheckEntrySignals();
		
			// Open trade if we have been signaled to do so
			if (entryDir != -1)
				if (NumOpenPositions(MagicNumber, entryDir) == 0)
					OpenNewPosition(entryDir);
		}
	}
	return (0);
}

